import psycopg2
import psycopg2.extras
from sqlalchemy.orm import scoped_session, sessionmaker
from sqlalchemy.schema import MetaData

def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

erp_host = 'localhost'
erp_usuario = 'openerp'
erp_nome = 'supervisor_santissima'
erp_senha = 'OVv5KfBjk5y6+m8NACgj'

try:
     conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                                 password=erp_senha, port='5432', connect_timeout=20)
     cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)

     cr.execute("""SELECT * from supervisor_cad_itens limit 1""")

     print '\n\n----> Conectado! <----\n\n'
     print dictfetchall(cr)

except Exception as e:
     print 'Erro: %s' % e



from sqlalchemy import create_engine
connection_supervisor = "postgresql+psycopg2://%s:%s@%s:%s/%s" % (erp_usuario,
                                                                  erp_senha,
                                                                  erp_host,
                                                                  '5432',
                                                                  erp_nome)
b_engine = create_engine(connection_supervisor, echo=False, pool_timeout=5,
                         logging_name='%s:%s' % ('localhost', 'panificadora'),
                         connect_args={'connect_timeout': 5})

b_session = scoped_session(sessionmaker(autocommit=True, bind=b_engine))
b_metadata = MetaData()
b_metadata.bind = b_engine
b_sess = b_session


from sqlalchemy.sql.expression import text
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Enum, Integer, String, VARCHAR, Boolean

from sigpdv.models.db_utils import b_metadata, b_session, remove_accents


class SupervisorCadOperadores(Entity):
    """
    Tabela de Cadastro de Operadores
    Prefixo: supope
    """
    using_options(metadata=b_metadata, session=b_session, tablename='supervisor_cad_operadores')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supope_codigo = Field(Integer(11), nullable=True)
    name = Field(VARCHAR(30))
    active = Field(Boolean, server_default=text('True'))
    supope_senha = Field(String(15))
    supope_operador_supervisor = Field(Enum('S', 'O', name='operador_supervisor'))
    supope_cancela_item = Field(Boolean)
    supope_desconto_item = Field(Boolean)
    supope_libera_restricao = Field(Boolean)
    # supope_biometria = Field(Text) # Quando nao tem biomeria no supervisor, erro na comanda

    def __repr__(self):
        _repr = "<supervisor_cad_operadores: %d, 'Nome=%s'>"
        vals = self.supope_codigo, remove_accents(self.name)
        return _repr % vals

from elixir import create_all, setup_all
try:
    create_all()
    setup_all()
except Exception as e:
    print 'Erro do create:', e

tbl = SupervisorCadOperadores
operador = tbl.get_by(supope_codigo=int('1'), active=True)
print 'operador: %s' % operador.supope_codigo
